Index: lib/set.c
===================================================================
--- lib/set.c	(revision 9)
+++ lib/set.c	(working copy)
@@ -393,6 +393,32 @@
   return ep;
 }
 
+sen_set_he *
+sen_set_cursor_curr(sen_set_cursor *c, void **key, void **value)
+{
+  entry *e, **ep;
+
+  if (c->rest < 0) { return NULL; }
+  ep = c->curr;
+  e = *(ep - 1);
+
+  switch (c->set->key_size) {
+  case 0 :
+    if (key) { *key = e->u.str.key; }
+    if (value) { *value = &e->u.str.val; }
+    break;
+  case sizeof(uint32_t) :
+    if (key) { *key = &e->key; }
+    if (value) { *value = &e->u; }
+    break;
+  default :
+    if (key) { *key = e->u.bin; }
+    if (value) { *value = &e->u.bin[c->set->key_size]; }
+    break;
+  }
+  return ep - 1;
+}
+
 sen_rc
 sen_set_cursor_close(sen_set_cursor *cursor)
 {
Index: lib/index.c
===================================================================
--- lib/index.c	(revision 9)
+++ lib/index.c	(working copy)
@@ -781,6 +781,19 @@
   return NULL;
 }
 
+const void *
+sen_records_curr_key(sen_records *r)
+{
+  sen_id *rid;
+  if (!r) { return NULL; }
+  if (!r->cursor) { return sen_records_next(r); }
+  if (sen_set_cursor_curr(r->cursor, (void **) &rid, NULL)) {
+    return sen_sym_key(r->index->keys, *rid);
+  }
+  return NULL;
+
+}
+
 int
 sen_records_find(sen_records *r, const void *key)
 {
Index: senna.h
===================================================================
--- senna.h	(revision 9)
+++ senna.h	(working copy)
@@ -124,6 +124,7 @@
 sen_rc sen_set_del(sen_set *set, sen_set_he *e);
 sen_set_cursor *sen_set_cursor_open(sen_set *set);
 sen_set_he *sen_set_cursor_next(sen_set_cursor *cursor, void **key, void **value);
+sen_set_he *sen_set_cursor_curr(sen_set_cursor *cursor, void **key, void **value);
 sen_rc sen_set_cursor_close(sen_set_cursor *cursor);
 sen_set_he *sen_set_sort(sen_set *set, int range,
                          int(*compar)(const sen_set_he *, const sen_set_he *));
